@echo off
setlocal
PUSHD %~dp0
::-------------------------------------------------
:: Autor: Erich Vonach
::        IT-Regionalbetreuer
:: Datum: 21.08.2019
::-------------------------------------------------
::
::------------ Variable setzten -------------------
::
set SourceDir=%cd%
set CName=Server
::
::
::-------------------------------------------------

::------------ SERVER-ermitteln -------------------
::
if EXIST "\\server\netlogon" goto noDFS
if EXIST "\\schule.aps\netlogon" goto DFS
::
:noDFS
set MYSERVER=Server
set MYSERVER1=Server
set MYSERVER2=Server
set VERKNUEPFUNGEN=Verknuepfungen_noDFS
set VERKNUEPFUNGEN_LEHRER=Verknuepfungen_noDFS_Lehrer
set BATCOPY=Bat_noDFS
::
goto Abfrage

:DFS
set MYSERVER=schule.aps
set MYSERVER1=schule.aps\dfs
set MYSERVER2=DCSchule
set VERKNUEPFUNGEN=Verknuepfungen_DFS
set VERKNUEPFUNGEN_LEHRER=Verknuepfungen_DFS_Lehrer
set BATCOPY=Bat_DFS
::
goto Abfrage
::
cls
::
:Abfrage
::
set PATCHNR-3=RBSrv19_W2k19_P003
set PATCHNR-2=RBSrv19_W2k19_P002
set PATCHNR-1=RBSrv19_W2k19_P001
set LOGFILE-3=\\%MYSERVER1%\Logs\%PATCHNR-3%.log
set LOGFILE-2=\\%MYSERVER1%\Logs\%PATCHNR-2%.log
set LOGFILE-1=\\%MYSERVER1%\Logs\%PATCHNR-1%.log
::
if exist %LOGFILE-3% goto noPatch
::
:: gehe zum Standardprogramm und kehre zu Befehle zurck
:: - wurde Batch schon ausgefhrt?
:: - ist Batch fr Betriebssystem geeignet?
::
goto Standardprogramm
::
:Befehle
::
::-----------------
::  Abfrage Eignung
::-----------------
::
If /i %computername%==%CName% goto ANWEISUNGEN
goto UNGEEIGNET
::
:ANWEISUNGEN
::
cls
::
color E0
::
echo.
echo --------------------------------------------------------------------------------------
echo.
echo      Dies ist der 3. Patch fr die Standardschulinstallation 2019.
echo      Dieser Patch setzt NICHT die Installation der vorangegangenen Patches voraus.
echo.
echo      Dieser Patch ist auch fr 'Windows 10-Client-taugliche' ltere Servergenerationen
echo      geeignet.
echo.
echo      Dieser Patch behebt das Problem mit z.T. fehlenden Startmeneintrgen der Benutzer.
echo.
echo ---------------------------------------------------------------------------------------
echo.
echo      Austausch des Gruppenrichtlinienobjektes 'C_CSE'
echo      - in der OU 'Schule - Computer'
echo      - in der OU 'Spezial - Computer'
echo.
echo -------------------------------------------------------------------------------
echo   Weiter mit "ja" plus ENTER    (andere Taste bricht ab)
echo -------------------------------------------------------------------------------
set /p AUSWAHL= fortsetzen?   
echo. -------------------------------------------------------
if /i "%AUSWAHL%"=="ja" goto WEITER_1
echo.
echo ... abgebrochen ...
ping -n 3 127.0.0.1 >nul
del %LOGFILE-3%
exit
rem -----Raus-----------------------
::
::
::---------------
::  Kopiervorgang
::---------------
::
:Weiter_1
::
echo.
:: ====LOG=============================================================================
echo.                                                                              					>>"%LOGFILE-3%"
echo --^>   Gruppenrichtlinienobjekt 'C_CSE' wurde ausgetaucht						      		>>"%LOGFILE-3%"
echo.                                                                              					>>"%LOGFILE-3%"
:: ====LOG=============================================================================
::
cscript "%SourceDir%\_Server\Tools\DeleteGPO.wsf" C_CSE
cscript "%SourceDir%\_Server\Tools\ImportGPO.wsf" %SourceDir%\_Server\GPO\C_CSE C_CSE /CreateIfNeeded
cscript "%SourceDir%\_Server\Tools\CreateEnvironmentFromXML.wsf" /XML:%SourceDir%\_Server\GPO\C_CSE.xml /createUserenabeled /Q
::
echo  --------------------------------------------------------------
cls
color 2E
echo.
echo   Vorgang wurde erfolgreich ausgefhrt!
echo.
echo.  Nach einem Tastendruck ffnet der
echo   Gruppenrichtlinieneditor
echo   zur Kontrolle des neuen Registryeintrages in 'C_CSE'
echo.
echo.
echo   Ein Log-File ist im Ordner '...\LOGS' zu finden
echo  --------------------------------------------------------------
echo.
::
pause
::
start /B %SystemRoot%\system32\gpmc.msc
::
goto ENDE
::
:UNGEEIGNET
echo  ---------------------------------------------------
cls
color 4F
echo.
echo.
echo  Falscher Rechner!
echo  Dieser Batch muss auf dem %CName% ausgefhrt werden.
echo.
echo  ---------------------------------------------------
echo.
pause
goto ENDE
::

:: ************************************************************************************
:: * Patch bereits ausgefhrt                                                         *
:: ************************************************************************************
:NoPatch
cls
color 4F
echo.
echo.
echo Diese Installationsroutine wurde auf diesem Rechner bereits ausgefhrt.
echo.
echo Siehe %LOGFILE-3%
echo.
echo.
pause
goto ENDE
::
::
:Standardprogramm

:: * Log-Datei erstellen *
::************************
::
:: ====LOG================================================================================
echo Autor E. Vonach    				      		      >>"%LOGFILE-3%"
echo Dieses Logfile bitte nicht lschen!				      >>"%LOGFILE-3%"
echo Patch ausgefhrt am                   %date%  um  Zeit:  %time%          >>"%LOGFILE-3%"
echo.
echo Protokoll:             %LOGFILE-2%                                       >>"%LOGFILE-3%"
echo ------------------------------------------------------------------------ >>"%LOGFILE-3%"
echo.                                                                         >>"%LOGFILE-3%"
:: ====LOG================================================================================
::

goto Befehle
:ENDE
endlocal
